﻿/***********************************************
* World Clock for The Matrix Online MMORPG - by Nicholas Phipps (phi)
* Some elements based on:
* JavaScript Image Clock- by JavaScript Kit (www.javascriptkit.com)
* This notice must stay intact for usage
* Visit JavaScript Kit at http://www.javascriptkit.com/ for this script and 100s more

***********************************************/
var imgArray = new Array()
imgArray = [i0,i1,i2,i3,i4,i5]
var daysOfWeek = new Array()
daysOfWeek = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"]
var monthsOfYear = new Array()
monthsOfYear = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"]
daysInMonth = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]

var qReport = new Array ();
var dstZones = new Array ();
var Local = new Date();
var GMToffset = Local.getTimezoneOffset();
var gAMPM = "";

var matrixFont = true; // 1 if true (shows Matrix Font) ... 0 if false (shows normal Font)
 // How long the fade effect should last (in milliseconds)
var FADE_DURATION = 1000;

var imageclock=new Object()
	//Enter path to clock digit images here, in order of 0-9, then "am/pm", then colon image:
	// Matrix Font characters
  imageclock.digits=["images/0.png", "images/1.png", "images/2.png", "images/3.png", "images/4.png", "images/5.png", "images/6.png", "images/7.png", "images/8.png", "images/9.png", "images/a.png", "images/p.png", "images/colon.png"]
  // Non-Matrix font characters	
  imageclock.digits_n=["images/n0.png", "images/n1.png", "images/n2.png", "images/n3.png", "images/n4.png", "images/n5.png", "images/n6.png", "images/n7.png", "images/n8.png", "images/n9.png", "images/na.png", "images/np.png", "images/colon.png"]
	imageclock.instances=0

var myOffset = 0;

	function setTimeValue(timestring){ // turn timestring (ie: 1:56:38) into string of images instead
		var sections=timestring.split(":")
		if (sections[0]=="0") //If hour field is 0 (aka 12 AM)
			sections[0]="12"
		else if (sections[0]>=13)
			sections[0]=sections[0]-12+""
	
		for (var i=0; i<sections.length; i++){
		
			if (sections[i].length==1){
				if (matrixFont){
					imgArray[i*2].src = imageclock.digits[0];
					imgArray[(i*2)+1].src = imageclock.digits[parseInt(sections[i])];
				}
				else{
					imgArray[i*2].src = imageclock.digits_n[0];
					imgArray[(i*2)+1].src = imageclock.digits_n[parseInt(sections[i])];
				}
			}
			else{
				if (matrixFont){
					imgArray[i*2].src = imageclock.digits[parseInt(sections[i].charAt(0))];
					imgArray[(i*2)+1].src = imageclock.digits[parseInt(sections[i].charAt(1))];
				}
				else{
					imgArray[i*2].src = imageclock.digits_n[parseInt(sections[i].charAt(0))];
					imgArray[(i*2)+1].src = imageclock.digits_n[parseInt(sections[i].charAt(1))];
					}
			}
		}
    
	}

	imageclock.display=function(){
		var clockinstance=this
	
		this.update()
		setInterval(function(){clockinstance.update()}, 1000)
	}

	imageclock.display.prototype.update=function(){
		var dateobj=new Date()
		myOffset = ZoneOffset((options.getValue("optsVarTimeZone")==(undefined || "")) ? "MCT (PST)" : options.getValue("optsVarTimeZone"));
		// var currenttime=dateobj.getHours()+":"+dateobj.getMinutes()+":"+dateobj.getSeconds() //create time string
		var currenttime=QHandler(myOffset) + ":" + dateobj.getSeconds(); //create time string
		setTimeValue(currenttime);
		if (matrixFont){
			ampm.src= (gAMPM == "AM")? imageclock.digits[10] : imageclock.digits[11];
		}
		else{
			ampm.src= (gAMPM == "AM")? imageclock.digits_n[10] : imageclock.digits_n[11];
		}
// 	CALCULATE DATE FROM CLOCK ... NOT UTC OR LOCAL
		var dDOW = dateobj.getUTCDay();
		var dMOY = dateobj.getUTCMonth();
		var dDOM = dateobj.getUTCDate();
		var dYear = dateobj.getYear();
		var leap = ((dYear % 4 == 0 && dYear % 100 != 0) || dYear % 400 == 0 )? true : false;
		if (leap) { daysInMonth[1] = 29; } else { daysInMonth[1] = 28; }
		var sections=currenttime.split(":");
		var dTime = parseInt(sections[0]) *60 + parseInt(sections[1]);
		var qGMTparse = parseFloat(myOffset);
		var qGMToffset_hrs = parseInt(qGMTparse, 10); 
		var qGMToffset_min= parseInt ( Math.round((qGMTparse-qGMToffset_hrs) * 100), 10);
		dTime += parseInt(qGMToffset_hrs * 60) + parseInt(qGMToffset_min) + GMToffset;

		if (dTime > 1440){ // tomorrow
			dTime -= 1440;
			dDOW = (dDOW + 1 > 6) ?  0 : dDOW + 1;
			dDOM += 1;
			if (dDOM > daysInMonth[dMOY]) {
				dDOM = 0;
				dMOY = (dMOY +1 > 11)? 0 : dMOY + 1;
			}
		}
		else if (dTime < 0){ // yesterday
			dTime += 1440;
			dDOW = (dDOW - 1 < 0) ?  6 : dDOW - 1;
			dDOM -= 1;
			if (dDOM < 0) {
				dMOY = (dMOY - 1 < 0)? 11 : dMOY;
				dDOM = daysInMonth[dMOY] - 1;
			}
		}
		dateDOW.innerText = daysOfWeek[dDOW];
		dateMonth.innerText = monthsOfYear[dMOY];
		dateDOM.innerText = dDOM;
	}

function view_onOpen() {
	new imageclock.display();
  matrixFont = (options.getValue("optsCBFont") == "ON");
  clockName.innerText = (options.getValue("optsEClockName") == (undefined || "")) ? "MCT (PST)" : options.getValue("optsEClockName");
	myOffset = ZoneOffset((options.getValue("optsVarTimeZone")==(undefined || "")) ? "MCT (PST)" : options.getValue("optsVarTimeZone"));
	CheckDST();
}

function View_mouseOver() {
  view.beginAnimation(function() { setClockOpacity(); }, // callback
                      255, // start value, 255 = full opacity
                      0, // end value, 0 = no opacity or "hidden"
                      FADE_DURATION); // duration in milliseconds

  view.beginAnimation(function() { setDateOpacity(); }, // callback
                      0, // start value, 0 = no opacity or "hidden"
                      255, // end value, 255 = full opacity
                      FADE_DURATION); // duration in milliseconds
}

function View_mouseOut() {
  view.beginAnimation(function() { setDateOpacity(); }, // callback
                      255, // start value, 255 = full opacity
                      0, // end value, 0 = no opacity or "hidden"
                      FADE_DURATION); // duration in milliseconds

  view.beginAnimation(function() { setClockOpacity(); }, // callback
                      0, // start value, 0 = no opacity or "hidden"
                      255, // end value, 255 = full opacity
                      FADE_DURATION); // duration in milliseconds
}

function setClockOpacity() {
//  element.opacity = event.value;
	i0.opacity = event.value;
	i1.opacity = event.value;
	colon1.opacity = event.value;
	i2.opacity = event.value;
	i3.opacity = event.value;
	colon2.opacity = event.value;
	i4.opacity = event.value;
	i5.opacity = event.value;
	ampm.opacity = event.value;
}

function setDateOpacity() {
//  element.opacity = event.value;
		dateDOW.opacity = event.value;
		dateMonth.opacity = event.value;
		dateDOM.opacity = event.value;
}

// Formats time into 24hrs
function Into24hrs (time) {
	if ( time > 1440) { time -= 1440 };
	else { if ( time <0) { time = 1440 + time } };

	return time;
}

//Formatted output of time
function FormatTime (time) {	
	var myTime = time;
	var fHours = Math.floor(time/60);
	if (fHours <= 9) {fHours = "0" + fHours}; 
	var fMins = time - (fHours * 60);
	if (fMins < 10) {fMins = "0" + fMins}; 
	if (fHours >= 12){
		fHours = fHours - 12;
		if (fHours < 10) { fHours = "0" + fHours};
		if (fHours == 0) { fHours = 12; gAMPM = "AM" };
		if (fHours > 0) { gAMPM = "PM" }
	}
	else { gAMPM = "AM" };
	var fTime = fHours + ":" + fMins;
	
	return fTime;
}

//Check whether daylight savings is on in any zone
function CheckDST () {	
//	var Local = new Date();
	var uNow = new Date();	

	var uYear = uNow.getYear();
	var leap = ((uYear % 4 == 0 && uYear % 100 != 0) || uYear % 400 == 0 )? true : false;
	MonthDays = new Array (0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334);
	var TodayNum = MonthDays [uNow.getMonth()] + uNow.getDate();	
	if (leap && TodayNum > 59) {TodayNum += 1};   
	//FirstSun8Feb, FirstSun15Mar, LastSunMar, FirstSunApr, LastSunSep, FirstSunOct, FirstSun15Oct,LastSunOct, 
	ChangeDays = new Array (43, 78, 85, 92, 274, 281, 295, 302); 
	var NumChangeDays = ChangeDays.length;
	if (leap) { for (var idx = 0; idx <= 6; idx++) {ChangeDays [idx] += 1} };
	DSTdays = new Array ();
	LastJan1 = new Date("Jan 1, " + uYear);
	DayJan1 = LastJan1.getDay ();	
	for (var idx2 = 0; idx2 < NumChangeDays; idx2++) {
		DSTdays [idx2] = ( TodayNum >= ChangeDays [idx2] - DayJan1 ) ? true : false; 
	}
	dstZones[0] = null;
	dstZones[1] = null;
	dstZones[2] =  ( DSTdays[3] && !DSTdays[7] ) ? true : false;//usa/canada
	dstZones[3] =  ( DSTdays[2] && !DSTdays[7] ) ? true : false;//uk/europe
	dstZones[4] =  ( DSTdays[7] || !DSTdays[2] ) ? true : false;//aus	
	dstZones[5] =  ( DSTdays[5] || !DSTdays[2] ) ? true : false;//aus-tasmania
	dstZones[6] =  ( DSTdays[5] || !DSTdays[1] ) ? true : false;//nz
	dstZones[7] =  ( DSTdays[2] && !DSTdays[4] ) ? true : false;//russia
}

// Sets how many hours ahead or behind the time is
function FormatOffset (time) {
	time = time - 660;
	var Report = null;
	var Direction  = (time > 0) ? "+" : "-";
	time = Math.abs (time);
	var Hours = time/660;

	Report = parseFloat((Direction =="-") ? Hours * -1 : Hours);

	return Report;
}

// The query handler which picks up the selected zone and returns the current time
function QHandler(ZoneData) {
	qReport[0] = ""; qReport[1] = ""; qReport[2] = ""; qReport[3] = "";	

	var qGMTparse = parseFloat(ZoneData);
	var qGMToffset_hrs = parseInt(qGMTparse, 10); 
	var qGMToffset_min= parseInt ( Math.round((qGMTparse-qGMToffset_hrs) * 100), 10);
	var qDSTperiod = ZoneData.charAt (ZoneData.length - 1);
	var qGMTperiod = 1440/60;
	if ( (qGMToffset_hrs > 12) || (qGMToffset_hrs <-11) ) {qReport[0] = "BAD DATA"; return};
	if (qDSTperiod > dstZones.length) {qReport[3] = "BAD DATA"};

	var relGMT = ((qGMToffset_hrs * 60) + qGMToffset_min) ; // 0 seconds offset - ((hours * 60)+ mins) * 60 + 0
	if (qDSTperiod>1 && dstZones[qDSTperiod]) { relGMT += 60; qReport[3] = "Yes (+1 hour)" } 
	else { qReport[3] = "No" }
	if (qDSTperiod == 0) {qReport[3] = "n/a"};
	if (qDSTperiod == 1) {qReport[3] = "uncertain"};

	var qPlaceTotMins = GMTnow(qPlaceTotMins);
	qPlaceTotMins += relGMT; 
	qPlaceTotMins = Into24hrs(qPlaceTotMins);
	qReport[0] = qPlaceTotMins;

	qReport[2] = FormatOffset(relGMT);

	var relLoc = relGMT - GMToffset;
	qReport[1] = FormatOffset(relLoc);


	var FormattedTime = FormatTime(qReport[0]);
	// var DisplayTime = FormattedTime + " (" + qReport[1] + ")";
	// return DisplayTime;
	return FormattedTime;
}

// What time is it now in GMT
function GMTnow() {
	var time = new Date();
	// var GMToffset = time.getTimezoneOffset();
	//GMT = Into24hrs((time.getHours() * 60) + time.getMinutes() + GMToffset) ;
	GMT = Into24hrs((time.getUTCHours() * 60) + time.getUTCMinutes()) ;

	return GMT;
}

//	#####################################
//	## OPTIONS HANDLING BEGINS HERE  ##
//	#####################################


// Enable Options Dialog
plugin.onShowOptionsDlg = ShowOptionsDlg;

var TimeZones = new Array(
	"Afghanistan",
	"Argentina",
	"Australia - Adelaide",
	"Australia - Brisbane",
	"Australia - Darwin",
	"Australia - Melbourne",
	"Australia - Perth",
	"Australia - Tasmania",
	"Bolivia",
	"Brazil - Andes",
	"Brazil - East",
	"Brazil - West",
	"Burma (Myanmar)",
	"Canada - Calgary",
	"Canada - Newfoundland",
	"Canada - Nova Scotia",
	"Canada - Quebec",
	"Canada - Toronto",
	"Canada - Vancouver",
	"Canada - Winnipeg",
	"China - Mainland",
	"China - Taiwan",
	"Colombia",
	"Cuba",
	"Egypt",
	"Finland",
	"France",
	"Germany",
	"Ghana",
	"Greece",
	"India",
	"Indonesia - Bali, Borneo",
	"Indonesia - Irian Jaya",
	"Indonesia - Sumatra, Java",
	"Iran",
	"Iraq",
	"Israel",
	"Jamaica",
	"Kenya",
	"Korea (North & South)",
	"London",
	"Malaysia",
	"Mexico City",
	"Morocco",
	"Nepal",
	"New Zealand",
	"Pakistan",
	"Peru",
	"Philippines",
	"Poland",
	"Russia - Kamchatka",
	"Russia - Moscow",
	"Russia - Vladivostok",
	"Singapore",
	"South Africa",
	"Spain",
	"Sweden",
	"Thailand",
	"Tokyo",
	"Tonga",
	"Turkey",
	"Ukraine",
	"Uzbekistan",
	"Vietnam",
	"USA Alaska",
	"USA Arizona",
	"USA Central",
	"USA Eastern",
	"USA Hawaii",
	"USA Indiana East",
	"USA Mountain",
	"USA Pacific",
	"MCT (PST)"
);

function OptionsDlgClosed(wnd, code) {
	if (code == gddIdOK) {
		// Save all the settings only if required
		options.putValue("optsCBFont", wnd.GetControl("optsCBFont").value ? "ON" : "OFF");
		options.putValue("optsEClockName", wnd.GetControl("optsEClockName").value);
		options.putValue("optsVarTimeZone", wnd.GetControl("optsCTZ").value);
		
		onOptionChanged();
	}
}

// Returns the zone offset based on the string selected in options
function ZoneOffset(zonestring) {
	var ZoneMap = new Object();

//	ZoneMap[""] = "";
	ZoneMap["Afghanistan"] = "4.30%0"
	ZoneMap["Argentina"] = "-3%0"
	ZoneMap["Australia - Adelaide"] = "9.30%4"
	ZoneMap["Australia - Brisbane"] = "10%0"
	ZoneMap["Australia - Darwin"] = "9.30%0"
	ZoneMap["Australia - Melbourne"] = "10%4"
	ZoneMap["Australia - Perth"] = "8%0"
	ZoneMap["Australia - Tasmania"] = "10%5"
	ZoneMap["Bolivia"] = "-4%0"
	ZoneMap["Brazil - Andes"] = "-5%1"
	ZoneMap["Brazil - East"] = "-3%1"
	ZoneMap["Brazil - West"] = "-4%1"
	ZoneMap["Burma (Myanmar)"] = "6.30%0"
	ZoneMap["Canada - Calgary"] = "-7%2"
	ZoneMap["Canada - Newfoundland"] = "-3.30%2"
	ZoneMap["Canada - Nova Scotia"] = "-4%2"
	ZoneMap["Canada - Quebec"] = "-5%2"
	ZoneMap["Canada - Toronto"] = "-5%2"
	ZoneMap["Canada - Vancouver"] = "-8%2"
	ZoneMap["Canada - Winnipeg"] = "-6%2"
	ZoneMap["China - Mainland"] = "8%1"
	ZoneMap["China - Taiwan"] = "8%0"
	ZoneMap["Colombia"] = "-5%0"
	ZoneMap["Cuba"] = "-5%1"
	ZoneMap["Egypt"] = "2%1"
	ZoneMap["Finland"] = "2%3"
	ZoneMap["France"] = "1%3"
	ZoneMap["Germany"] = "1%3"
	ZoneMap["Ghana"] = "0%0"
	ZoneMap["Greece"] = "2%3"
	ZoneMap["India"] = "5.30%0"
	ZoneMap["Indonesia - Bali, Borneo"] = "8%0"
	ZoneMap["Indonesia - Irian Jaya"] = "9%0"
	ZoneMap["Indonesia - Sumatra, Java"] = "7%0"
	ZoneMap["Iran"] = "3.30%1"
	ZoneMap["Iraq"] = "3%0"
	ZoneMap["Israel"] = "2%1"
	ZoneMap["Jamaica"] = "-5%1"
	ZoneMap["Kenya"] = "3%0"
	ZoneMap["Korea (North & South)"] = "9%0"
	ZoneMap["London"] = "0%3"
	ZoneMap["Malaysia"] = "8%0"
	ZoneMap["Mexico City"] = "-6%1"
	ZoneMap["Morocco"] = "0%0"
	ZoneMap["Nepal"] = "5.45%0"
	ZoneMap["New Zealand"] = "12%6"
	ZoneMap["Pakistan"] = "5%0"
	ZoneMap["Peru"] = "-5%0"
	ZoneMap["Philippines"] = "8%0"
	ZoneMap["Poland"] = "1%3"
	ZoneMap["Russia - Kamchatka"] = "11%7"
	ZoneMap["Russia - Moscow"] = "3%7"
	ZoneMap["Russia - Vladivostok"] = "9%7"
	ZoneMap["Singapore"] = "8%0"
	ZoneMap["South Africa"] = "2%0"
	ZoneMap["Spain"] = "1%3"
	ZoneMap["Sweden"] = "1%3"
	ZoneMap["Thailand"] = "7%0"
	ZoneMap["Tokyo"] = "9%0"
	ZoneMap["Tonga"] = "12%0"
	ZoneMap["Turkey"] = "2%3"
	ZoneMap["Ukraine"] = "3%1"
	ZoneMap["Uzbekistan"] = "5%0"
	ZoneMap["Vietnam"] = "7%0"
	ZoneMap["USA Alaska"] = "-9%2"
	ZoneMap["USA Arizona"] = "-9%0"
	ZoneMap["USA Central"] = "-6%2"
	ZoneMap["USA Eastern"] = "-5%2"
	ZoneMap["USA Hawaii"] = "-10%0"
	ZoneMap["USA Indiana East"] = "-5%0"
	ZoneMap["USA Mountain"] = "-7%2"
	ZoneMap["USA Pacific"] = "-8%2"
	ZoneMap["MCT (PST)"] = "-8%2"

	return (ZoneMap[zonestring]);
}

function onOpenOptionsClick() {
  pluginHelper.showOptionsDialog();
}

function ShowOptionsDlg(wnd) {
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Clock Title: ",10,12,60,24);
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Use Matrix Font for time display",25,35,250,35);
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Time Zone: ",10,60,60,24);

	var optsEClockName = wnd.AddControl(gddWndCtrlClassEdit, 0, "optsEClockName", "", 65, 5, 200, 30);
	optsEClockName.value=(options.getValue("optsEClockName")==(undefined || "")) ? "MCT (PST)" : options.getValue("optsEClockName"); // if clock name blank reset to default

	var optsCBFont = wnd.AddControl(gddWndCtrlClassButton,  gddWndCtrlTypeButtonCheck, "optsCBFont", "", 10, 32, 10, 24);
	optsCBFont.value=(options.getValue("optsCBFont") == "ON");

	var optsCTZ = wnd.AddControl(gddWndCtrlClassList, gddWndCtrlTypeListDrop, "optsCTZ", TimeZones, 70, 57, 160, 24);
	optsCTZ.value=(options.getValue("optsVarTimeZone")==(undefined || "")) ? "MCT (PST)" : options.getValue("optsVarTimeZone"); // if time zone blank default to MegaCity Time (US PST)

	wnd.onClose = OptionsDlgClosed;
}

function onOptionChanged() {
// update live values
  matrixFont = (options.getValue("optsCBFont") == "ON");
  clockName.innerText = options.getValue("optsEClockName");
  myOffset = ZoneOffset((options.getValue("optsVarTimeZone")==(undefined || "")) ? "MCT (PST)" : options.getValue("optsVarTimeZone"));
}